searchNodes=[{"doc":"Defines a Bandit server as part of a supervision tree. A typical child spec to start a Bandit server hosting a plug looks like: { Bandit , plug : { MyApp.Plug , :arg_passed_to_plug_init } , options : [ port : 4000 ] } Three options are supported: scheme : One of :http or :https . If :https is supported, you will need to specify certfile and keyfile in the transport_options subsection of options . plug : The plug to handle connections. Can be specified as MyPlug or {MyPlug, plug_opts} read_timeout : How long to wait for data from the client before timing out and closing the connection, specified in milliseconds. Defaults to 60_000 options : Options to pass to ThousandIsland . For an exhaustive list of options see the ThousandIsland documentation, however some common options are: port : The port to bind to. Defaults to 4000 num_acceptors : The number of acceptor processes to run. This is mostly a performance tuning knob and can usually be left at the default value of 10 transport_module : The name of the module which provides basic socket functions. This overrides any value set for scheme and is intended for cases where control over the socket at a fundamental level is needed. transport_options : A keyword list of options to be passed into the transport socket's listen function","ref":"Bandit.html","title":"Bandit","type":"module"},{"doc":"","ref":"Bandit.html#child_spec/1","title":"Bandit.child_spec/1","type":"function"},{"doc":"A Plug definition","ref":"Bandit.html#t:plug/0","title":"Bandit.plug/0","type":"type"},{"doc":"Defines behaviour to be implemented by HTTP Adapters in addition to those defined by Plug.Conn.Adapter .","ref":"Bandit.Adapter.html","title":"Bandit.Adapter","type":"behaviour"},{"doc":"Returns the local connection info (port, IP and SSL certificate) for a connection.","ref":"Bandit.Adapter.html#c:get_local_data/1","title":"Bandit.Adapter.get_local_data/1","type":"callback"},{"doc":"Returns the initial connection data (method, request URI and headers) for a client connection.","ref":"Bandit.Adapter.html#c:read_headers/1","title":"Bandit.Adapter.read_headers/1","type":"callback"},{"doc":"Returns whether or not this connection is secure","ref":"Bandit.Adapter.html#c:secure?/1","title":"Bandit.Adapter.secure?/1","type":"callback"},{"doc":"The requested URI exactly as it appears in the request line at the beginning of an HTTP request, NOT broken up into path &amp; query components.","ref":"Bandit.Adapter.html#t:request_uri/0","title":"Bandit.Adapter.request_uri/0","type":"type"},{"doc":"Delegates all inplementation of the ThousandIsland.Handler behaviour to an implementation specified in state. Allows for clean separation between protocol implementations &amp; friction free protocol selection &amp; upgrades.","ref":"Bandit.DelegatingHandler.html","title":"Bandit.DelegatingHandler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bandit.DelegatingHandler.html#child_spec/1","title":"Bandit.DelegatingHandler.child_spec/1","type":"function"},{"doc":"","ref":"Bandit.DelegatingHandler.html#start_link/1","title":"Bandit.DelegatingHandler.start_link/1","type":"function"},{"doc":"An HTTP 1.0 &amp; 1.1 Thousand Island Handler","ref":"Bandit.HTTP1.Handler.html","title":"Bandit.HTTP1.Handler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bandit.HTTP1.Handler.html#child_spec/1","title":"Bandit.HTTP1.Handler.child_spec/1","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_close/2 .","ref":"Bandit.HTTP1.Handler.html#handle_close/2","title":"Bandit.HTTP1.Handler.handle_close/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_connection/2 .","ref":"Bandit.HTTP1.Handler.html#handle_connection/2","title":"Bandit.HTTP1.Handler.handle_connection/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_error/3 .","ref":"Bandit.HTTP1.Handler.html#handle_error/3","title":"Bandit.HTTP1.Handler.handle_error/3","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_shutdown/2 .","ref":"Bandit.HTTP1.Handler.html#handle_shutdown/2","title":"Bandit.HTTP1.Handler.handle_shutdown/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_timeout/2 .","ref":"Bandit.HTTP1.Handler.html#handle_timeout/2","title":"Bandit.HTTP1.Handler.handle_timeout/2","type":"function"},{"doc":"","ref":"Bandit.HTTP1.Handler.html#start_link/1","title":"Bandit.HTTP1.Handler.start_link/1","type":"function"},{"doc":"Represents the state of an HTTP/2 connection","ref":"Bandit.HTTP2.Connection.html","title":"Bandit.HTTP2.Connection","type":"module"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#handle_frame/3","title":"Bandit.HTTP2.Connection.handle_frame/3","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#init/2","title":"Bandit.HTTP2.Connection.init/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#send_data/7","title":"Bandit.HTTP2.Connection.send_data/7","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#send_headers/6","title":"Bandit.HTTP2.Connection.send_headers/6","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#send_push/4","title":"Bandit.HTTP2.Connection.send_push/4","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#shutdown_connection/4","title":"Bandit.HTTP2.Connection.shutdown_connection/4","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Connection.html#stream_terminated/4","title":"Bandit.HTTP2.Connection.stream_terminated/4","type":"function"},{"doc":"A description of a connection error","ref":"Bandit.HTTP2.Connection.html#t:error/0","title":"Bandit.HTTP2.Connection.error/0","type":"type"},{"doc":"Encapsulates the state of an HTTP/2 connection","ref":"Bandit.HTTP2.Connection.html#t:t/0","title":"Bandit.HTTP2.Connection.t/0","type":"type"},{"doc":"Errors as defined in RFC7540§11","ref":"Bandit.HTTP2.Errors.html","title":"Bandit.HTTP2.Errors","type":"module"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#cancel/0","title":"Bandit.HTTP2.Errors.cancel/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#compression_error/0","title":"Bandit.HTTP2.Errors.compression_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#connect_error/0","title":"Bandit.HTTP2.Errors.connect_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#enhance_your_calm/0","title":"Bandit.HTTP2.Errors.enhance_your_calm/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#flow_control_error/0","title":"Bandit.HTTP2.Errors.flow_control_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#frame_size_error/0","title":"Bandit.HTTP2.Errors.frame_size_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#http_1_1_requires/0","title":"Bandit.HTTP2.Errors.http_1_1_requires/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#inadequate_security/0","title":"Bandit.HTTP2.Errors.inadequate_security/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#internal_error/0","title":"Bandit.HTTP2.Errors.internal_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#no_error/0","title":"Bandit.HTTP2.Errors.no_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#protocol_error/0","title":"Bandit.HTTP2.Errors.protocol_error/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#refused_stream/0","title":"Bandit.HTTP2.Errors.refused_stream/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#settings_timeout/0","title":"Bandit.HTTP2.Errors.settings_timeout/0","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Errors.html#stream_closed/0","title":"Bandit.HTTP2.Errors.stream_closed/0","type":"function"},{"doc":"An error code as defined for GOAWAY and RST_STREAM errors","ref":"Bandit.HTTP2.Errors.html#t:error_code/0","title":"Bandit.HTTP2.Errors.error_code/0","type":"type"},{"doc":"Helpers for working with flow control window calculations","ref":"Bandit.HTTP2.FlowControl.html","title":"Bandit.HTTP2.FlowControl","type":"module"},{"doc":"","ref":"Bandit.HTTP2.FlowControl.html#compute_recv_window/2","title":"Bandit.HTTP2.FlowControl.compute_recv_window/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.FlowControl.html#update_send_window/2","title":"Bandit.HTTP2.FlowControl.update_send_window/2","type":"function"},{"doc":"An HTTP/2 handler. Responsible for: Coordinating the parsing of frames &amp; attendant error handling Tracking connection state as represented by Bandit.HTTP2.Connection structs Marshalling send requests from child streams into the parent connection for processing","ref":"Bandit.HTTP2.Handler.html","title":"Bandit.HTTP2.Handler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bandit.HTTP2.Handler.html#child_spec/1","title":"Bandit.HTTP2.Handler.child_spec/1","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_close/2 .","ref":"Bandit.HTTP2.Handler.html#handle_close/2","title":"Bandit.HTTP2.Handler.handle_close/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_error/3 .","ref":"Bandit.HTTP2.Handler.html#handle_error/3","title":"Bandit.HTTP2.Handler.handle_error/3","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Handler.html#start_link/1","title":"Bandit.HTTP2.Handler.start_link/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Serializable.html","title":"Bandit.HTTP2.Serializable","type":"protocol"},{"doc":"","ref":"Bandit.HTTP2.Serializable.html#serialize/2","title":"Bandit.HTTP2.Serializable.serialize/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Serializable.html#t:t/0","title":"Bandit.HTTP2.Serializable.t/0","type":"type"},{"doc":"Settings as defined in RFC7540§6.5.2 and §11.3","ref":"Bandit.HTTP2.Settings.html","title":"Bandit.HTTP2.Settings","type":"module"},{"doc":"A collection of settings as defined in RFC7540§6","ref":"Bandit.HTTP2.Settings.html#t:t/0","title":"Bandit.HTTP2.Settings.t/0","type":"type"},{"doc":"Carries out state management transitions per RFC7540§5.1. Anything having to do with the internal state of a stream is handled in this module. Note that sending of frames on behalf of a stream is a bit of a split responsibility: the stream itself may update state depending on the value of the end_stream flag (this is a stream concern and thus handled here), but the sending of the data over the wire is a connection concern as it must be serialized properly &amp; is subject to flow control at a connection level","ref":"Bandit.HTTP2.Stream.html","title":"Bandit.HTTP2.Stream","type":"module"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#get_send_window_size/1","title":"Bandit.HTTP2.Stream.get_send_window_size/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#owner?/2","title":"Bandit.HTTP2.Stream.owner?/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#recv_data/2","title":"Bandit.HTTP2.Stream.recv_data/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#recv_end_of_stream/2","title":"Bandit.HTTP2.Stream.recv_end_of_stream/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#recv_headers/5","title":"Bandit.HTTP2.Stream.recv_headers/5","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#recv_rst_stream/2","title":"Bandit.HTTP2.Stream.recv_rst_stream/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#recv_window_update/2","title":"Bandit.HTTP2.Stream.recv_window_update/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#send_data/2","title":"Bandit.HTTP2.Stream.send_data/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#send_end_of_stream/2","title":"Bandit.HTTP2.Stream.send_end_of_stream/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#send_headers/1","title":"Bandit.HTTP2.Stream.send_headers/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#send_push_headers/2","title":"Bandit.HTTP2.Stream.send_push_headers/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#start_push/4","title":"Bandit.HTTP2.Stream.start_push/4","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#stream_terminated/2","title":"Bandit.HTTP2.Stream.stream_terminated/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.Stream.html#terminate_stream/2","title":"Bandit.HTTP2.Stream.terminate_stream/2","type":"function"},{"doc":"A description of a stream error","ref":"Bandit.HTTP2.Stream.html#t:error/0","title":"Bandit.HTTP2.Stream.error/0","type":"type"},{"doc":"An HTTP/2 stream state","ref":"Bandit.HTTP2.Stream.html#t:state/0","title":"Bandit.HTTP2.Stream.state/0","type":"type"},{"doc":"An HTTP/2 stream identifier","ref":"Bandit.HTTP2.Stream.html#t:stream_id/0","title":"Bandit.HTTP2.Stream.stream_id/0","type":"type"},{"doc":"A single HTTP/2 stream","ref":"Bandit.HTTP2.Stream.html#t:t/0","title":"Bandit.HTTP2.Stream.t/0","type":"type"},{"doc":"Represents a collection of HTTP/2 streams, accessible by stream id or pid. Provides the ability to track streams with any identifier, even though it only manages explicit state for existing (current) streams.","ref":"Bandit.HTTP2.StreamCollection.html","title":"Bandit.HTTP2.StreamCollection","type":"module"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#can_send_new_push_promise/1","title":"Bandit.HTTP2.StreamCollection.can_send_new_push_promise/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#get_active_stream_by_pid/2","title":"Bandit.HTTP2.StreamCollection.get_active_stream_by_pid/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#get_stream/2","title":"Bandit.HTTP2.StreamCollection.get_stream/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#last_remote_stream_id/1","title":"Bandit.HTTP2.StreamCollection.last_remote_stream_id/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#next_local_stream_id/1","title":"Bandit.HTTP2.StreamCollection.next_local_stream_id/1","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#put_stream/2","title":"Bandit.HTTP2.StreamCollection.put_stream/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#update_initial_send_window_size/2","title":"Bandit.HTTP2.StreamCollection.update_initial_send_window_size/2","type":"function"},{"doc":"","ref":"Bandit.HTTP2.StreamCollection.html#update_max_concurrent_streams/2","title":"Bandit.HTTP2.StreamCollection.update_max_concurrent_streams/2","type":"function"},{"doc":"A collection of Stream structs, accessisble by id or pid","ref":"Bandit.HTTP2.StreamCollection.html#t:t/0","title":"Bandit.HTTP2.StreamCollection.t/0","type":"type"},{"doc":"The initial protocol implementation used for all connections. Switches to a specific protocol implementation based on configuration, ALPN negotiation, and line heuristics.","ref":"Bandit.InitialHandler.html","title":"Bandit.InitialHandler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Bandit.InitialHandler.html#child_spec/1","title":"Bandit.InitialHandler.child_spec/1","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_close/2 .","ref":"Bandit.InitialHandler.html#handle_close/2","title":"Bandit.InitialHandler.handle_close/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_data/3 .","ref":"Bandit.InitialHandler.html#handle_data/3","title":"Bandit.InitialHandler.handle_data/3","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_error/3 .","ref":"Bandit.InitialHandler.html#handle_error/3","title":"Bandit.InitialHandler.handle_error/3","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_shutdown/2 .","ref":"Bandit.InitialHandler.html#handle_shutdown/2","title":"Bandit.InitialHandler.handle_shutdown/2","type":"function"},{"doc":"Callback implementation for ThousandIsland.Handler.handle_timeout/2 .","ref":"Bandit.InitialHandler.html#handle_timeout/2","title":"Bandit.InitialHandler.handle_timeout/2","type":"function"},{"doc":"","ref":"Bandit.InitialHandler.html#start_link/1","title":"Bandit.InitialHandler.start_link/1","type":"function"},{"doc":"Raised by bandit adapters if they are commanded to read a body which already been read.","ref":"Bandit.Adapter.AlreadyReadError.html","title":"Bandit.Adapter.AlreadyReadError","type":"exception"},{"doc":"Raised by bandit adapters if they are commanded to send a request before request headers have been read.","ref":"Bandit.Adapter.UnreadHeadersError.html","title":"Bandit.Adapter.UnreadHeadersError","type":"exception"}]